using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Drawing2D;

namespace DuplaPufferHasznalat
{
  public partial class frmAblak : Form
  { 
    /// <summary>
    /// Puffer a grafiknak. Az ablakban elhelyeztnk egy panelt (pnAlap),
    /// ami teljesen kitlti a men alatti terletet, s az AutoScroll=True.
    /// A pnAlap panelre a grgets automatikus megvalstsa miatt van szksg.
    /// Erre tesznk egy msodik panelt, ami a rajzlap feladatt fogja
    /// elltni. A rajzlap mrett a kpernyhz igaztjuk.
    /// </summary>
    BufferedGraphics bgPuffer;
    public frmAblak()
    { InitializeComponent();
      // Lekrdezzk az els kpernyt.
      Screen Scr = Screen.AllScreens[0];
      // A rajzlapot a kpernyvel azonos mretre vlasztjuk
      pnRajzLap.Height = Scr.WorkingArea.Height;
      pnRajzLap.Width = Scr.WorkingArea.Width;
      // Referencia az alkalmazs BufferedGraphicsManager objektumhoz
      BufferedGraphicsContext bgcContext = BufferedGraphicsManager.Current;
      // Puffer ltrehozsa a rajzlaphoz
      bgPuffer = bgcContext.Allocate(pnRajzLap.CreateGraphics(),
         Scr.WorkingArea);
      // A pufferbeli rajzlap fehrre festse
      bgPuffer.Graphics.FillRectangle(Brushes.White, 
         Scr.WorkingArea);
    }
    
    private void frmAblak_FormClosed(object sender, FormClosedEventArgs e)
    { // A puffer ltal lefoglalt erforrs felszabadtsa
      bgPuffer.Dispose();
    }

    private void pnRajzLap_Paint(object sender, PaintEventArgs e)
    { // A pufferbeli rajzlap tartalmnak megjelentse a valdi rajzlapon
      bgPuffer.Render(); 
    }

    private void tsmiRajzolsKzvetlenlAPanelre_Click(object sender, EventArgs e)
    { // Referencia krse a tnyleges rajzlap festvszonjhoz
      Graphics gr = pnRajzLap.CreateGraphics();
      // Vonalhzs kzvetlenl a rajzlapra
      gr.DrawLine(Pens.Blue, 0, 0, 200, 200);
    }

    private void tsmiRajzolsDuplapufferhasznlattal_Click(object sender, 
      EventArgs e)
    { // Rajzolunk a memriapufferbe egy olyan ellipszist, ami kihasznlja a
      // teljes rajzlapot
      bgPuffer.Graphics.DrawEllipse(Pens.Blue, 
        pnRajzLap.DisplayRectangle);
      // rvnytelentjk a rajzlapot --> Paint esemny a rajzlapon
      pnRajzLap.Refresh();

    }
  }
}
