using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Drawing2D;

namespace GrafikaNemPaint
{
  public partial class frmRajzols : Form
  {
    Pen Toll;
    Random Vletlen;
    Brush Ecset;
    private Ecsetek EcsetTpus;
    Sztr EcsetMen;

    public frmRajzols()
    { InitializeComponent();
      Vletlen = new Random();
      // A toll szne piros
      Toll= new Pen(Color.Red, 2);
      EcsetTpus = Ecsetek.Gradiens;
      // Ltrehozumk egy gradiens tpus ecsetet
      // A gradiens ellltshoz kt pontot kell megadni,
      // s hozzjuk kell rendelni kt sznt
      Ecset = new LinearGradientBrush(new Point(0, 0),
        new Point(10, 110), Color.Red, Color.Blue);
      // Sztr ltrehozsa ecsettpusok s menpontok 
      // sszerendelshez
      EcsetMen = new Sztr();
      EcsetMen[Ecsetek.Egyszn] = tsmiEgyszn;
      EcsetMen[Ecsetek.Gradiens] = tsmiGradiens;
      EcsetMen[Ecsetek.Mints] = tsmiMints;
    }
    
    /// <summary>
    /// Vonal rajzols
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void tsbtVonal_Click(object sender, EventArgs e)
    { Graphics gr = pnLap.CreateGraphics();
      gr.DrawLine(Toll, Vletlen.Next(pnLap.Width),
        Vletlen.Next(pnLap.Height),
        Vletlen.Next(pnLap.Width),
        Vletlen.Next(pnLap.Height));
     
    }

    /// <summary>
    /// Ellipszis rajzols
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void tsbtEllipszis_Click(object sender, EventArgs e)
    { Graphics gr = pnLap.CreateGraphics();
      gr.DrawEllipse(Toll, Vletlen.Next(pnLap.Width), 
        Vletlen.Next(pnLap.Height),
        Vletlen.Next(pnLap.Width),
        Vletlen.Next(pnLap.Height));
    }

    /// <summary>
    /// Tglalap rajzols
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void tsbtTglalap_Click(object sender, EventArgs e)
    { Graphics gr = pnLap.CreateGraphics();
      gr.DrawRectangle(Toll, Vletlen.Next(pnLap.Width),
        Vletlen.Next(pnLap.Height),
        Vletlen.Next(pnLap.Width),
        Vletlen.Next(pnLap.Height));
    }

    /// <summary>
    /// Kifestett hromszg rajzolsa
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void tsbtKifestettHromszg_Click(object sender, EventArgs e)
		{	int x = 110 + Vletlen.Next(pnLap.Width - 200);
			int y = 5 + Vletlen.Next(pnLap.Height - 110);
      // Alakzat trspontjainak definilsa
      Point[] Pontok ={new Point(x+10,y+5),new Point(x-100,y+100), 
        new Point(x+100,y+100),new Point(x+10,y+5)};
      // Ler a festvszonhoz
      Graphics gr = pnLap.CreateGraphics();
      // Alakzat objektum ltrehozsa
      GraphicsPath grp=new GraphicsPath();
      // Alakzat kpnek definilsa vonalak segtsgvel
      grp.AddLines(Pontok);
      // Alakzat kifestse
      gr.FillPath(Ecset, grp);
		}

    /// <summary>
    /// Kifests kp segtsgvel megadott mintval
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void tsmiMints_Click(object sender, EventArgs e)
    {
        Ecset.Dispose();
        try
        {
            Bitmap Kp = (Bitmap)Image.FromFile("../../08fu.bmp", true);
            Ecset = new TextureBrush(Kp);
            ((TextureBrush)Ecset).WrapMode = System.Drawing.Drawing2D.WrapMode.Tile;
            EcsetTpus = Ecsetek.Mints;
        }
        catch (System.IO.FileNotFoundException)
        {
            MessageBox.Show("Nem sikerlt megnyitni a kp llomnyt!");
        }
    }

    /// <summary>
    /// j gradiens ecset ltrehozsa
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
		private void tsmiGradiens_Click(object sender, EventArgs e)
    { Ecset.Dispose();
      Ecset = new LinearGradientBrush(new Point(0, 0),
				new Point(10, 110), Color.Red, Color.Blue);
      EcsetTpus = Ecsetek.Gradiens;
	}

    /// <summary>
    /// j egyszn ecset ltrehozsa
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
		private void tsmiEgyszn_Click(object sender, EventArgs e)
    { Ecset.Dispose();
			Ecset=new SolidBrush(Color.FromArgb(Vletlen.Next(Int32.MaxValue)));
      EcsetTpus = Ecsetek.Egyszn;
		}

    /// <summary>
    /// Belltja Ecsettpus kivlasztsa lenylmen elemeinek 
    /// kivlasztottsgi llapott
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void tssbEcsetTpus_DropDownOpening(object sender, EventArgs e)
    { // Trljk mindegyik pipt
      for (int i = 0; i < 3; i++)
        EcsetMen[(Ecsetek)i].Checked = false;
      // Kijelljk az aktulis tpust
      EcsetMen[EcsetTpus].Checked = true;
    }
  }


  public enum Ecsetek
  {
    Egyszn,
    Gradiens,
    Mints
  }
}